Resolution: Fixed Affected version: 252
Description

This patch changes the repository statistics view to honor the "commiter => user" mapping. Without it, the statistics page is pretty
much useless for it.

After creating this patch, i discovered issue #2624 which is about the same issue, and also provides a patch; unfortunately it has
been mostly ignored for 4 years.

| still decided to submit my own patch, because it has some advantages:

e |t properly deals with the case were a committer name has not been mapped to a user. The patch at issue #2624 seems to map
such committers to the empty string.

¢ |t sorts case insensitive, which is quite useful for me.

¢ |t merges homonyms, as requested by #2065. Actually, this point could also be a drawback for some projects, namely if two
distinct people sharing the same name work there. So perhaps this is not desired. | can change the patch to remove this, which
will then only merge committers mapping to the same user.

Related issues:

Related to Redmine - Feature #2624: Repository statistics should honour user-... Closed 2009-01-30
Related to Redmine - Feature #2065: Commit graph should merge homonyms Closed
Related to Redmine - Feature #2761: Factorize user name in /repository/statis... Closed 2009-02-16
Related to Redmine - Defect #14338: svn: repository statistics issue when use... Closed
Has duplicate Redmine - Feature #7353: Map repository authors to Redmine user... Closed 2011-01-17

Associated revisions

Revision 13351 - 2014-08-26 15:58 - Jean-Baptiste Barth

Move some RepositoriesController logic to Repository#stats_by_author (#13487).

Revision 13352 - 2014-08-26 19:15 - Jean-Baptiste Barth

Fix text failing on some rubies/sql drivers because of improper length in Change#action (#13487).

Revision 13353 - 2014-08-26 19:32 - Jean-Baptiste Barth

Honnor committers/users mapping in repository statistics (#13487).

Revision 13361 - 2014-08-31 19:23 - Jean-Baptiste Barth

Optimize committers/users map retrieval for statistic graphs (#13487).

Revision 13362 - 2014-08-31 19:36 - Jean-Baptiste Barth
Fix syntax for ruby 1.8.7 (#13487).

History

#1 - 2013-03-15 16:48 - Anonymous

This patch also fixes issues #7353 and #2761 (which are duplicates of other issues, but nobody flagged them as such, and | don't seem to be allowed
to flag issues as duplicates).

#2 - 2013-03-15 17:40 - Etienne Massip
- Category set to SCM
#3 - 2013-03-16 14:29 - Daniel Felix

Well | would like to test this issue. But currently I'm at the hospital. Just in case of the description, this sounds to be worth to look at it. :-)

#4 - 2013-03-17 11:59 - Anonymous

No worries. Get back to good health and return home from hospital, redmine is no nearly as important as that!

| just hope this patch won't share the fate of those others and still be here, unresolved (i.e. neither accepted nor rejected) in four years g.

#5 - 2013-03-17 12:41 - Daniel Felix

Thanks!

Well | think this one will find a faster way. If there is the next minor release available this could be set to this release or at least the next major.

#6 - 2013-04-17 22:18 - Anonymous

Sadly after 1 month, it seems nobody had a chance to look at this. Too bad :-(. It would be nice to get at least some feedback on these things... as it
is, development of Redmine seems to happen mostly behind closed doors and is not very welcome to outside contributions :-(.

Perhaps somebody did look at this patch and found an issue with that -- but without any feedback, that's impossible to tell for me :-(.

#7 - 2013-04-18 02:42 - Toshi MARUYAMA

Because this patch does not have tests, | don't know it is correct or not.
I think it is better that Graph logic is moved from controller to helper in order to test.
See: source:tags/2.3.0/test/unit/lib/redmine/helpers/gantt_test.rb

#8 - 2013-04-18 11:26 - Anonymous

OK, that makes sense. | am not yet very familiar with the testing system (of Redmine, or any other Ruby / RoR app in general -- | am fairly new to
Ruby). | will investigate the gantt_test you referred me to, thanks for the point. | will try and see if | can do something. Likewise, moving the logic from
controller to helper is something | can do, if you prefer that.

However, currently | am swamped with other work, so it's easily possible that another month or two will pass before | get to address either point. If
somebody else beats me to that with a better patch, | won't complain ;-) but in any case, the ball is now in my court, as | have some clear feedback.
Thank you very much for that, and for your work on Redmine in general.

#9 - 2014-02-19 11:26 - Keats .
Hi,

it's working great.

Thanks

#10 - 2014-05-15 12:51 - txemi M

| would love to see this patch in next version,
thanks.

#11 - 2014-08-26 15:41 - Jean-Baptiste Barth

- Related to Defect #14338: svn: repository statistics issue when user names only differ in case added

#12 - 2014-08-26 15:44 - Jean-Baptiste Barth
- Tracker changed from Patch to Defect
- Assignee set to Jean-Baptiste Barth

- Target version set to 2.6.0

| started looking at it and adding some tests, I'll commit it soon, hopefully for an integration in 2.6.0 (it's a fix
but it has been here for a very long time, so it can wait past 2.5.3).

Maxin Samuel: thanks for the proposals but | started again from scratch because, as Toshi said, this code should'nt be here (some code belongs to
the model imho, some other to helpers for SVG rendering). Moreover your patch has many effects in one and I'd like to keep things in separate

commits so Toshi or Jean-Philippe can easily revert this if they judge it's not correct. Anyway it helped me see where the problem is so thanks for
your contribution !

#13 - 2014-08-26 15:45 - Jean-Baptiste Barth

- Related to deleted (Feature #7353: Map repository authors to Redmine users not used in statistics)

#14 - 2014-08-26 15:45 - Jean-Baptiste Barth

2025-05-01 2/3


https://www.redmine.org/projects/redmine/repository/svn/entry/tags/2.3.0/test/unit/lib/redmine/helpers/gantt_test.rb
https://www.redmine.org/users/1364

- Has duplicate Feature #7353: Map repository authors to Redmine users not used in statistics added

#15 - 2014-08-26 18:04 - Toshi MARUYAMA

Ruby 1.8.7 PostgreSQL test fails.
https://travis-ci.org/marutosi/redmine-bb/jobs/33601888

#16 - 2014-08-26 19:16 - Jean-Baptiste Barth
Toshi MARUYAMA wrote:

Ruby 1.8.7 PostgreSQL test fails.
https://travis-ci.org/marutosi/redmine-bb/jobs/33601888

Thanks! That should be fixed in r13352. There's no check on Change#action length as it's not user-controlled but it seems SQL drivers don't react the
same way so we may be better adding some...

#17 - 2014-08-26 19:36 - Jean-Baptiste Barth

| added committers/users mapping in r13353, but | did not add the other features discussed by Max in the original issue (sort committer names,
merge homonyms). In case tests pass, and if JPL and Toshi are OK with that, this feature could be released with Redmine 2.6.0.

Note that this can have a bit of performance impact because with this implementation multiple queries are run to find the correct user (it relies on
Repository#find_committer_user while it could use Changeset#user_id directly). I'llimprove that in the next few days.

Also it made me realize there are missing tests for Repository#find_committer_user and | think some edge cases are not handled correctly. I'll dig into
that later.

#18 - 2014-08-26 20:53 - Toshi MARUYAMA
Toshi MARUYAMA wrote:

Ruby 1.8.7 PostgreSQL test fails.
https://travis-ci.org/marutosi/redmine-bb/jobs/33601888

Because | restarted, log disappeared.
Ruby 1.9.3 PostgreSQL test fails due to same reason.
https://travis-ci.org/marutosi/redmine-bb/jobs/33601897

1) Error:
test_stats_by_author_reflect_changesets_and_changes (RepositoryTest) :
ActiveRecord::StatementInvalid: PG::StringDataRightTruncation: ERROR: value too long for type character varyi
ng (1)

INSERT INTO "changes" ("action", "branch", "changeset_id", "from_path", "from_revision", "path", "revision")
VALUES ($1, $2, $3, $4, $5, $6, $7) RETURNING "id"

#19 - 2014-08-27 19:23 - Jean-Baptiste Barth

- File 0001-Optimize-committers-users-map-retrieval-for-statisti.patch added

Fwiw here's the patch to cut down the number of SQL queries by relying directly on Changeset#user_id. On my test repo (10k changesets, 40k file
changes, 90 distinct committers), it cuts the number of SQL queries from 216 to 9.

But | don't commit it now because I'd like to have the feedback of the ClI system which is down until the end of the week. | don't know if Oracle and
SQLServer will support the custom select forms and | didn't see "AS" elsewhere in the codebase, so | want to be able to revert it quickly if it breaks.

#20 - 2014-09-01 06:37 - Jean-Baptiste Barth
- Status changed from New to Closed
- Resolution set to Fixed

- Affected version set to 2.5.2

All tests passing with r13361/r13362, so | close this issue. Other features deserve their own issue (but as said elsewhere | doubt they're a good idea
in the general case for now ; maybe someday when we have something prettier client-side).

Files
repos-stats-map-users.patch 2.56 KB 2013-03-15 Anonymous
0001-Optimize-committers-users-map-retrieval-for-statisti.patch 2.48 KB 2014-08-27 Jean-Baptiste Barth
